; Smile
; 09-06-2006
; www.assert.i8.com
; mailto: db05@bk.ru

__rva1 =0	;    
		; offset in source file

__rva2 =0	;    
		; offset in target file

__tbl  equ 0	;   PE 
		; PE section table

__org =0	; VA  
		; VA address of changes beginning

__diff =0	;   
		; Total changes size

__va_valid =0	;     
		; Result of search in section table

__pefile =0	;    PE
		; PE file loaded

__baseorg=0	;   
		; Save org position

__maxrva =0	;   
		; Maximal file size


macro __format_pe [arg]
{
 common
  use32
  local ..argc
  ..argc = 0
  __tbl equ arg
  __pefile = 1

 forward
  ..argc = ..argc+1

 common
  if (..argc < 1) | ((..argc-1) mod 3) <> 0
   error 'Bad section definition'
  end if
}


macro __maxorg arg
{
 if arg eqtype ''
  virtual at 0
   file arg
   __maxrva = $
  end virtual
 else
  __maxrva = arg
 end if
}


macro __setorg addr
{
 org addr
 __org = addr
 __baseorg = addr
 __diff = 0
}


macro org addr
{
 __diff = __diff+(__org-$)
 __org = addr
 org addr
}


macro __find_section
{
 local ptr,base,va,rva,size
 virtual at 0
  dd __tbl
  ptr = 4
  load base dword from 0
  repeat $/12
   load va dword from ptr
   load rva dword from ptr+4
   load size dword from ptr+8
   ptr = ptr + 12
   va = va + base
   if (__org >= va) & (__org-va+__diff < size)
    __rva2 = rva+__org-va
    __va_valid = 1
   end if
  end repeat
 end virtual
}


macro __mkdiff
{
 __diff = __diff+($-__org)
 __va_valid = 0

 if __pefile = 1
  __find_section
  if __va_valid = 1
   __mkcmd __rva1, __rva2, __diff
  else
   display 'Out of section ',<__org,16>,'-',<$,16>,13,10
   error 'Out of section'
  end if
 else
  __rva2 = __baseorg
  if (__maxrva <> 0) & (__rva2 > __maxrva-1)
   display 'Out of file, rva = ',<__rva2,16>,13,10
   error 'Out of file'
  end if
  __mkcmd __rva1, __rva2, __diff
 end if
 __rva1 = __rva1 + __diff
}


macro __mkchng addr, [arg]
{
 common
  __setorg addr
 forward
  arg
 common
  __mkdiff
}


macro __mkcmd offs1,offs2,diff
{
 display '#',<offs1,16>,' ',<offs2,16>,' ',<diff,16>,13,10
}


;   display,   
;   www.flatassembler.net/board
macro __digit num
{
 if num < 10
  display '0'+num
 else
  display 'A'+num-10
 end if
}

macro __display arg1,arg2
{
 if arg2 eq
  display arg1
 else
  local ..tmp
  ..tmp = arg1
  virtual at 0
   repeat 32
    if ..tmp > 0
     db ..tmp mod arg2
     ..tmp = ..tmp / arg2
    end if
   end repeat
   repeat $
    load ..tmp byte from $-%
    __digit ..tmp
   end repeat
   if $ = 0
    display '0'
   end if
  end virtual
 end if
}

macro display [arg]
{
 __display arg
}